package com.qmth.teachcloud.report.report;

import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.report.TeachcloudReportApplication;
import com.qmth.teachcloud.report.business.service.CourseUnitOperateService;
import org.apache.commons.io.IOUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 课程单元演示制作测试类
 * @Author: CaoZixuan
 * @Date: 2022-03-01
 */
@SpringBootTest(classes = {TeachcloudReportApplication.class})
@RunWith(SpringRunner.class)
public class CourseUnitOperateServiceTest {
    @Resource
    private CourseUnitOperateService courseUnitOperateService;

    private MultipartFile transferFtoM(File file) throws IOException {
        FileInputStream input = new FileInputStream(file);
        return new MockMultipartFile("file", file.getName(), "text/plain", IOUtils.toByteArray(input));
    }

    @Test
    public void testChangeBasicCourse() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\基础课程文件.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeBasicCourse(m, schoolId));
    }

    @Test
    public void testChangeSysOrg() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\机构文件.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeSysOrg(m, schoolId));
    }

    @Test
    public void testChangeSysUser() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\用户变更.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeSysUser(m, schoolId));
    }

    @Test
    public void testChangeBasicStudent(){
        Long schoolId = 2L;
        courseUnitOperateService.changeStudent(schoolId);
    }

    @Test
    public void testStep(){
        List<Long> x = new ArrayList<>();
        for (int i = 0; i < 20000; i++) {
            x.add((long) i);
        }
        List<List<Long>> step = SystemConstant.getStepList(x);
        System.out.println(step.size());
        step.forEach(e -> System.out.println(e.size()));
    }
}
